<template>
  <form>
    <appRow>
      <appCol>
        <app-select
          v-model="model.contract"
          :errorMessage="errorMessages.contract"
          label="Contrato"
          :items="contractList"
          item-text="name"
          :rules="[rules.required]"
          item-value="id"
          required
          error-message="Este campo es requerido"
          @input="updateModel"
        ></app-select
      ></appCol>
    </appRow>
    <appRow>
      <appCol cols="6">
        <app-text-field
          v-model="model.id"
          :errorMessage="errorMessages.id"
          label="Id"
          :disabled="!creating"
          placeholder="numero único"
          :rules="[rules.required]"
          @input="updateModel"
        ></app-text-field>
      </appCol>
      <appCol cols="6">
        <app-text-field
          v-model="model.email"
          :errorMessage="errorMessages.email"
          label="email"
          :rules="[rules.email, rules.required]"
          @input="updateModel"
          placeholder="Correo electrónico"
        ></app-text-field>
      </appCol>
      <appCol cols="6">
        <app-text-field
          v-model="model.firstName"
          :errorMessage="errorMessages.firstName"
          label="Nombre"
          placeholder="Nombre"
          :rules="[rules.required]"
          @input="updateModel"
        ></app-text-field>
      </appCol>
      <appCol cols="6">
        <app-text-field
          v-model="model.lastName"
          label="Apellidos"
          :errorMessage="errorMessages.lastName"
          placeholder="Apellidos"
          :rules="[rules.required]"
          @input="updateModel"
        ></app-text-field
      ></appCol>
      <appCol cols="6">
        <app-text-field
          v-model="model.dateOfBirth"
          label="Fecha de nacimiento"
          :errorMessage="errorMessages.dateOfBirth"
          placeholder="YYYY-MM-DD"
          :rules="[rules.date]"
          @input="updateModel"
        ></app-text-field
      ></appCol>
      <appCol cols="6">
        <app-text-field
          v-model="model.employeeId"
          label="Id de Empleado"
          placeholder="Número de Empleado"
          :errorMessage="errorMessages.employeeId"
          :rules="[rules.required]"
          @input="updateModel"
        ></app-text-field
      ></appCol>
    </appRow>
  </form>
</template>

<script>
import constants from '../../constants';
import formMixin from '../../mixins/form';
import apiMixin from '../../mixins/api';
export default {
  name: 'userForm',
  mixins: [formMixin, apiMixin],
  props: {
    user: { type: Object, default: () => ({}) },
    creating: { type: Boolean, default: false },
    errorMessages: { type: Object, default: () => ({}) },
  },
  data: () => ({
    model: { ...constants.userModel },
  }),
  watch: {
    user(val) {
      if (val) {
        this.model = val;
      }
    },
  },
  methods: {
    updateModel() {
      this.$emit('update:model', this.model);
      this.$emit('update:error-messages', {});
    },
  },
};
</script>

<style></style>
